from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar(
    "T",
    bound="PredictionService_GetLatestPoolsSimplifiedResponse_200PredictionsItemSimplifiedPredictionPointforoutput",
)


@attr.s(auto_attribs=True)
class PredictionService_GetLatestPoolsSimplifiedResponse_200PredictionsItemSimplifiedPredictionPointforoutput:
    """  """

    cpr: Union[Unset, float] = UNSET
    date: Union[Unset, str] = UNSET
    smm: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cpr = self.cpr
        date = self.date
        smm = self.smm

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cpr is not UNSET:
            field_dict["cpr"] = cpr
        if date is not UNSET:
            field_dict["date"] = date
        if smm is not UNSET:
            field_dict["smm"] = smm

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cpr = d.pop("cpr", UNSET)

        date = d.pop("date", UNSET)

        smm = d.pop("smm", UNSET)

        prediction_service_get_latest_pools_simplified_response_200_predictions_item_simplified_prediction_pointforoutput = cls(
            cpr=cpr,
            date=date,
            smm=smm,
        )

        prediction_service_get_latest_pools_simplified_response_200_predictions_item_simplified_prediction_pointforoutput.additional_properties = (
            d
        )
        return prediction_service_get_latest_pools_simplified_response_200_predictions_item_simplified_prediction_pointforoutput

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
